#include "vbcompat.bi"
#include "windows.bi"

Dim sTemp As String

Dim As Integer i, j, first_space_location, second_space_location, third_space_location, fourth_space_location
Dim As String first_item, second_part, second_item, third_part, third_item, fourth_item, fourth_part
Dim nbre As Integer
ReDim buffer(32768) As String
Dim i_buffer As Integer
Dim in_prim As Integer
Dim found As Integer
Dim As Double longit, latit, altit 
Dim As Double long_min, long_max, lat_min, lat_max 
Dim As Double long_origin, lat_origin 
Dim As Long nb_max_tris, nb_max_vertex
Dim As Double x, y, z 

Dim sTxtDsfFile As String
Dim sIntermFile As String
Dim sOutputFile As String
Dim As Integer div, reste 

Dim type_prim As Integer


Dim uname As String ' receives the value read from the INI file
Dim slength As Long ' receives length of the returned string

Dim As Double min_lat, min_long, min_alt 
Dim As Double max_lat, max_long 
Dim As Double moy_lat, moy_long 
Dim ini_file_path As String

Dim As Long nb_primitives, nb_selected_primitives

'-----------------------------------------------------------------------
'FR  ETAPE 0: LECTURE DU FICHIER DE PARAMETRES (fichier dsf_extract.ini)

uname = Space(255) 
slength = GetCurrentDirectory (255, uname)
ini_file_path = Left(uname, slength) + "\" + "dsf_extract.ini"

'verification de l'existance du fichier ini
If (FileLen(ini_file_path)=0) Then
	Print ("dsf_extract.ini file not found; This file shall be in the same directory as dsf_extract.exe")
	End -1
EndIf

sIntermFile = Left(uname, slength) + "\" + "dsf_extract.tmp"

' Lecture lat_min
uname = Space(255) 
' Read from the INI file
slength = GetPrivateProfileString("dsf_extract", "lat_min", "", uname, 255, ini_file_path)
If (slength=0) Then
	Print ("Error reading lat_min in ini file")
	End -1
Else
	uname = Left(uname, slength) 
	lat_min = Val (uname)
EndIf

' Lecture lat_max
uname = Space(255) 
' Read from the INI file
slength = GetPrivateProfileString("dsf_extract", "lat_max", "", uname, 255, ini_file_path)
If (slength=0) Then
	Print ("Error reading lat_max in ini file")
	End -1
Else
	uname = Left(uname, slength) 
	lat_max = Val (uname)
EndIf

' Lecture long_min
uname = Space(255) 
' Read from the INI file
slength = GetPrivateProfileString("dsf_extract", "long_min", "", uname, 255, ini_file_path)
If (slength=0) Then
	Print ("Error reading long_min in ini file")
	End -1
Else
	uname = Left(uname, slength) 
	long_min = Val (uname)
EndIf

' Lecture long_max
uname = Space(255) 
' Read from the INI file
slength = GetPrivateProfileString("dsf_extract", "long_max", "", uname, 255, ini_file_path)
If (slength=0) Then
	Print ("Error reading long_max in ini file")
	End -1
Else
	uname = Left(uname, slength) 
	long_max = Val (uname)
EndIf

' Lecture nom fichier d'entree
uname = Space(255) 
' Read from the INI file
slength = GetPrivateProfileString("dsf_extract", "input_file", "", uname, 255, ini_file_path)
If (slength=0) Then
	Print ("Error reading input_file in ini file")
	End -1
Else
	sTxtDsfFile = Left(uname, slength) 
EndIf

' Lecture nom fichier de sortie
uname = Space(255) 
' Read from the INI file
slength = GetPrivateProfileString("dsf_extract", "output_file", "", uname, 255, ini_file_path)
If (slength=0) Then
	Print ("Error reading output_file in ini file")
	End -1
Else
	sOutputFile = Left(uname, slength) 
EndIf

' Lecture nombre max de vertex
uname = Space(255) 
' Read from the INI file
slength = GetPrivateProfileString("dsf_extract", "nb_max_vertex", "", uname, 255, ini_file_path)
If (slength=0) Then
	Print ("Error reading nb_max_vertex in ini file")
	End -1
Else
	uname = Left(uname, slength) 
	nb_max_vertex = Val (uname)
EndIf

' Lecture nombre max de tris
uname = Space(255) 
' Read from the INI file
slength = GetPrivateProfileString("dsf_extract", "nb_max_tris", "", uname, 255, ini_file_path)
If (slength=0) Then
	Print ("Error reading nb_max_vertex in ini file")
	End -1
Else
	uname = Left(uname, slength) 
	nb_max_tris = Val (uname)
EndIf


'-----------------------
'FR  ETAPE 1: EXTRACTION
'FR  L'objet de cette premire tape est d'extraire du terrain les primitives
'FR  qui ont au moins un vertex dans la zone long_min, long_max, lat_min, lat_max
'FR  Ces primitives sont copies dans un fichier intermdiaire
'EN  STEP 1: EXTRACTION
'EN  The purpose of this first step is to extact from the terrain the primitives
'EN  that have at least one vertex in the area: long_min, long_max, lat_min, lat_max
'EN  These primitives are copied into an intermediate file

nb_primitives = 0
nb_selected_primitives = 0

Open sTxtDsfFile For Input As 1
Open sIntermFile For Output As 2

in_prim = 0
found = 0

While Not EOF(1)
  Line Input #1, sTemp
  first_space_location = Instr(sTemp, " ")
  If (first_space_location > 0) Then
  	first_item = Left(sTemp, first_space_location-1)
  	second_part = Right(sTemp,Len(sTemp)-first_space_location)
  Else
  	first_item = sTemp
  	second_part = ""
  EndIf
  If (sTemp <> "") Then
    
    If (first_item = "BEGIN_PRIMITIVE") Then
    'FR  dtection de debut de primitive; dbut enregistrement dans buffer intermdiaire
    'EN  start of primitive detected; record in intermediate buffer is started
      in_prim = 1
      i_buffer = 1
      buffer(i_buffer) = sTemp
      nb_primitives = nb_primitives + 1
    Else
      If (in_prim = 1) Then
        'FR  on est tjrs dans la primitive; on continue l'enregistrement dans buffer
        'EN  we still are in the primitive; record in buffer is continued
        i_buffer = i_buffer + 1
        buffer(i_buffer) = sTemp
        If (first_item = "PATCH_VERTEX") Then
          second_space_location = Instr(second_part, " ")
  	       second_item = Left(second_part, second_space_location-1)
  	       third_part = Right(second_part,Len(second_part)-second_space_location)
          third_space_location = Instr(third_part, " ")
  	       third_item = Left(third_part, third_space_location-1)
  	       fourth_part = Right(third_part,Len(third_part)-third_space_location)
  	       longit = Val(second_item)
  	       latit = Val (third_item)
          If (latit > lat_min) And (latit < lat_max) And (longit > long_min) And (longit < long_max) Then
            'FR un des points de la primitive est dans la zone  extraire
            'EN at least one point in the primitive is the the zone to be extracted
            found = 1
          End If
        End If
        If (first_item = "END_PRIMITIVE") Then
        'FR  fin de la primitive
          in_prim = 0
          
          'FR Si la primitive est dans la zone  extraire
          'FR => copie dans fichier intermdiaire
          'EN If the primitive is in the zone to be extracted
          'FR => copy this primitive into the intermediate file
          '-------------------------------------------
          If (found = 1) Then
            found = 0
            nb_selected_primitives = nb_selected_primitives + 1
            Print "Step 1: ";nb_selected_primitives;"/";nb_primitives
            For i = 1 To i_buffer
              Print #2, buffer(i)
            Next i
          End If
        End If
      End If
    End If
  End If

Wend
Close 1
Close 2

'-----------------------------------------------------
'FR ETAPE 2: CREATION DES BUFFERS DE POINTS ET D'INDEX
'EN STEP 2: CREATION OF VERTEX AND INDEX BUFFERS

ReDim tx(nb_max_vertex) As Double
ReDim ty(nb_max_vertex) As Double
ReDim tz(nb_max_vertex) As Double
' x: east
' y: up
' z: south

ReDim tidx(nb_max_tris) As Double
ReDim buf_sav(nb_max_vertex) As String

Dim index_xyz As Long
Dim index_idx As Long

Dim deb_tri_fan As Long
Dim fin_tri_fan As Long
Dim As Long idx2, idx3 

ReDim px(3) As Double
ReDim py(3) As Double
ReDim pz(3) As Double

nb_primitives = 0

Open sIntermFile For Input As 1

in_prim = 0
found = 0
index_xyz = 0
index_idx = 0

While Not EOF(1)
  Line Input #1, sTemp
  first_space_location = Instr(sTemp, " ")
  If (first_space_location > 0) Then
  	first_item = Left(sTemp, first_space_location-1)
  	second_part = Right(sTemp,Len(sTemp)-first_space_location)
  Else
  	first_item = sTemp
  	second_part = ""
  EndIf
  If (sTemp <> "") Then  
    If (first_item = "BEGIN_PRIMITIVE") Then
    'FR  dtection de debut de primitive; dbut enregistrement dans buffer
    'EN  Start of primitive => start of recording into intermediate buffer
      in_prim = 1
      i_buffer = 1
      buffer(i_buffer) = sTemp
      nb_primitives = nb_primitives + 1
      Print "Step 2: ";nb_primitives;"/";nb_selected_primitives
    Else
      If (in_prim = 1) Then
        'FR  on est tjrs dans la primitive; on continue l'enregistrement dans buffer
        'EN  we still are in the primitive; record in buffer is continued
        i_buffer = i_buffer + 1
        buffer(i_buffer) = sTemp
        If (first_item = "END_PRIMITIVE") Then
          in_prim = 0
          
          'FR  fin de mmorisation de la primitive dans le buffer intermdiaire
          'FR  => traitement de la primitive copie dans le buffer
          'EN  End of recording of the primitive into the intermediate buffer
          'EN  => primitive recorded into the buffer is now to be processed
          first_space_location = Instr(buffer(1), " ")
  	       second_part = Right(buffer(1),Len(buffer(1))-first_space_location)
          type_prim = ValInt(second_part)

          If (type_prim = 2) Then  'Type 2 = TRI_FAN
             'FR cration des points et index de l'objet de type "tri_fan"
             'FR les points sont copis dans les vecteurs tx, ty, tz
             'FR les index sont copis dans le vecteur tidx
             'EN Vertex and index of the tri_fan object are created
             'FR vertex are copied into tx, ty, tz arrays
             'FR index are copied into tidx array
             deb_tri_fan = index_xyz
             fin_tri_fan = index_xyz + i_buffer - 3
             For i = 2 To i_buffer - 1
                'FR copie des coordonnes dans les tableaux tx, ty, tz
                'EN coordinates are copied into arrays tx, ty, tz
                first_space_location = Instr(buffer(i), " ")
  	             second_part = Right(buffer(i),Len(buffer(i))-first_space_location)
                second_space_location = Instr(second_part, " ")
  	             second_item = Left(second_part, second_space_location-1)
  	             third_part = Right(second_part,Len(second_part)-second_space_location)
                third_space_location = Instr(third_part, " ")
  	             third_item = Left(third_part, third_space_location-1)
  	             fourth_part = Right(third_part,Len(third_part)-third_space_location)
                fourth_space_location = Instr(fourth_part, " ")
  	             fourth_item = Left(fourth_part, fourth_space_location-1)
  	             longit = Val(second_item)
  	             latit = Val (third_item)
  	             altit = Val (fourth_item)
                x = (longit-long_min) * 1852# * 60# * Cos(3.1415927 / 180# * latit)
                y = altit
                z = (latit-lat_min) * 1852# * 60#
                tx(index_xyz) = x / 100#
                ty(index_xyz) = y / 100#
                tz(index_xyz) = -1# * z / 100#
                buf_sav(index_xyz) = buffer(i)
                index_xyz = index_xyz + 1
 					 if (index_xyz = nb_max_vertex) then
						Print ("vertex number too large; increase nb_max_vertex in ini file")
						End -1
 					 EndIf            
 				 Next i
             
             'FR cration des index correspondants dans le tableau tidx des index
             'EN corresponding index are created into tidx array
             idx2 = deb_tri_fan + 1
             idx3 = deb_tri_fan + 2
             Do
               tidx(index_idx) = deb_tri_fan
               index_idx = index_idx + 1
 					if (index_idx = nb_max_tris) then
						Print ("TRIs number too large; increase nb_max_tri in ini file")
						End -1
					EndIf  
               tidx(index_idx) = idx2
               index_idx = index_idx + 1
 					if (index_idx = nb_max_tris) then
						Print ("TRIs number too large; increase nb_max_tri in ini file")
						End -1
					EndIf  
               tidx(index_idx) = idx3
               index_idx = index_idx + 1
 					if (index_idx = nb_max_tris) then
						Print ("TRIs number too large; increase nb_max_tri in ini file")
						End -1
					EndIf  
               idx2 = idx2 + 1
               idx3 = idx3 + 1
             Loop Until (idx3 > fin_tri_fan)
          End If
          

          If (type_prim = 0) Then   'Type 0: TRI
             'FR cration des points et index de l'objet de type "tri"
             'FR les points sont copis dans les vecteurs tx, ty, tz
             'FR les index sont copis dans le vecteur tidx
             'EN Vertex and index of the tri object are created
             'EN vertex are copied into tx, ty, tz arrays
             'EN index are copied into tidx array
             For i = 0 To ((i_buffer - 2) / 3 - 1)
                found = 0
                
                'FR copie du tri dans des vecteurs intermdiaires px, py, pz
                'FR et vrification qu'ils sont dans la zone long_min, long_max, lat_min, lat_max
                'EN the 3 TRI points coordinates are copied into intermediate vectors px, py, pz
                'EN it is verified that at least one of these three points is in the lat/long area
                For j = 0 To 2
                  first_space_location = Instr(buffer((i * 3) + 2 + j), " ")
  	               second_part = Right(buffer((i * 3) + 2 + j),Len(buffer((i * 3) + 2 + j))-first_space_location)
                  second_space_location = Instr(second_part, " ")
  	               second_item = Left(second_part, second_space_location-1)
  	               third_part = Right(second_part,Len(second_part)-second_space_location)
                  third_space_location = Instr(third_part, " ")
  	               third_item = Left(third_part, third_space_location-1)
  	               fourth_part = Right(third_part,Len(third_part)-third_space_location)
                  fourth_space_location = Instr(fourth_part, " ")
  	               fourth_item = Left(fourth_part, fourth_space_location-1)
  	               longit = Val(second_item)
  	               latit = Val (third_item)
  	               altit = Val (fourth_item)
                  If (latit > lat_min) And (latit < lat_max) And (longit > long_min) And (longit < long_max) Then
                     'FR  une des points de la primitive est dans la zone  extraire
                     'EN  one point of the primitive is in the lat/long area
                     found = 1
                  End If
                  'FR conversion et mmorisation intermdiaire
                  'EN conversion and intermediate recording
                  px(j + 1) = (longit-long_min) * 1852# * 60# * Cos(3.1415927 / 180# * latit)
                  py(j + 1) = altit
                  pz(j + 1) = (latit-lat_min) * 1852# * 60#
                Next j
                
                'FR si au moins un point du tri est dans la zone lat/long, copie dans tx, ty, tz, tidx
                'EN if at least one point of the TRI is in the lat/long zone, then the TRI is copied into tx, ty, tz, tidx
                If (found = 1) Then
                  found = 0
                  tx(index_xyz) = px(1) / 100#
                  ty(index_xyz) = py(1) / 100#
                  tz(index_xyz) = -1# * pz(1) / 100#
                  buf_sav(index_xyz) = buffer((i * 3) + 2)
                  tidx(index_idx) = index_xyz
                  index_xyz = index_xyz + 1
 						if (index_xyz = nb_max_vertex) then
							Print ("vertex number too large; increase nb_max_vertex in ini file")
							End -1
 						EndIf                    
 						index_idx = index_idx + 1
	 					if (index_idx = nb_max_tris) then
							Print ("TRIs number too large; increase nb_max_tri in ini file")
							End -1
 						EndIf  
                  tx(index_xyz) = px(2) / 100#
                  ty(index_xyz) = py(2) / 100#
                  tz(index_xyz) = -1# * pz(2) / 100#
                  buf_sav(index_xyz) = buffer((i * 3) + 3)
                  tidx(index_idx) = index_xyz
                  index_xyz = index_xyz + 1
	 					if (index_xyz = nb_max_vertex) then
							Print ("vertex number too large; increase nb_max_vertex in ini file")
							End -1
 						EndIf  
                  index_idx = index_idx + 1
	 					if (index_idx = nb_max_tris) then
							Print ("TRIs number too large; increase nb_max_tri in ini file")
							End -1
 						EndIf  
                  tx(index_xyz) = px(3) / 100#
                  ty(index_xyz) = py(3) / 100#
                  tz(index_xyz) = -1# * pz(3) / 100#
                  buf_sav(index_xyz) = buffer((i * 3) + 4)
                  tidx(index_idx) = index_xyz
                  index_xyz = index_xyz + 1
	 					if (index_xyz = nb_max_vertex) then
							Print ("vertex number too large; increase nb_max_vertex in ini file")
							End -1
 						EndIf  
                  index_idx = index_idx + 1
	 					if (index_idx = nb_max_tris) then
							Print ("TRIs number too large; increase nb_max_tri in ini file")
							End -1
 						EndIf  
                End If
             Next i
          End If
        End If
      End If
    End If
  End If

Wend

Close 1

'---------------------------------------------------------------------------
'FR ETAPE 3: DETERMINATION DU POINT LE PLUS HAUT
'EN STEP 3: FIND THE HIGHEST POINT
Dim origin_y As Double
Dim index_origin As Integer
Dim string_origin As String

origin_y = -2000000

For i = 1 To index_xyz
  If (ty(i - 1) > origin_y) Then
    origin_y = ty(i - 1)
    long_origin = tx(i - 1)
    lat_origin = tz(i - 1)
    index_origin = i
    string_origin = buf_sav(i-1)
    
  End If
Next i

'--------------------------------------------------------
'FR ETAPE 4: ECRITURE DU FICHIER DE SORTIE AU FORMAT OBJ8
'EN SETP 4: OUTPUT FILE IS WRITTEN IN THE OBJ8 FORMAT

Print
Print "Writing output file"

Open sOutputFile For Output As 3

Print #3, "I"
Print #3, "800"
Print #3, "OBJ"
Print #3, ""
Print #3, "TEXTURE"
Print #3, "POINT_COUNTS " + Str(index_xyz) + " 0 0 " + Str(index_idx)
Print #3, ""

For i = 1 To index_xyz
  Print #3, "VT " + Format(tx(i - 1)-long_origin,"0.000000") + " " + Format(ty(i - 1) - origin_y,"0.000000") + " "; Format(tz(i - 1)-lat_origin,"0.000000") + " "; " 0.0 1.0 0.0 0.0 1.0 # " + buf_sav(i - 1)
Next i
Print #3, ""


For i = 1 To index_idx
  Print #3, "IDX " + Str(tidx(i - 1))
Next i

Print #3, ""
Print #3, "TRIS 0 " + Str(index_idx)

Print #3, ""
Print #3, "# Origin: "; string_origin
Print
Print "Coordinates of the vertex correponding to the origin of the output object:"
Print "             longitude  latitude    altitude(m)
Print string_origin

Close 3

End


